#include <stdio.h>
#include <dpmi.h>
#include <go32.h>
#include <sys/nearptr.h>
#include <sys/segments.h>
#include <sys/movedata.h>
#include <math.h>
#include <pc.h>

typedef struct pal8
 {
   char r;
   char g;
   char b;
 } pal8;
typedef struct pal8_ex
 {
   char b;
   char g;
   char r;
   char n;

 } pal8_ex;

unsigned char *scr;
unsigned char *bmp,*bmpa;
unsigned char *texture;

int sint[360];
int i,j,n;
int MAX_DOT;
unsigned char *screen;

static int ad;

/**/
void setmode(int mode)
{
  __dpmi_regs r;

  r.x.ax=mode;
  __dpmi_int(0x10,&r);

}
/**/
void flip(char *scr,int x,int y)
{

  char s[256*256];

  memcpy(s,scr,256*256);
  for (i=0;i<y;i++)
    memcpy(&scr[i*x],&s[(y-i-1)*x],x);

}
/**/
void load_bmp(char *filename, char *bmp, pal8 *pal)
{
  FILE *f;
  int bv,bh;
  int i;
  pal8_ex bpal[256];

  f=fopen(filename,"rb");
  fseek(f,18,0);
  fread(&bv,4,1,f);
  fread(&bh,4,1,f);
  printf("%d\n",bv);
  printf("%d\n",bh);
  fseek(f,54,0);
  fread(bpal,256*4,1,f);
  fseek(f,1078,0);
  fread(bmp,bv*bh,1,f);
  fclose(f);


  for (i=0;i<256;i++)
    {

      pal[i].r=bpal[i].r>>2;
      pal[i].g=bpal[i].g>>2;
      pal[i].b=bpal[i].b>>2;

    }

  flip(texture,bv,bh);

}
/**/
void set_palette(pal8 *pal)
{
  outportb(0x3c8,0);
  outportsb(0x3c9,(unsigned char *) pal,256*3);

}
/**/
void vbl(void)
{
  while (inportb(0x3da)&8);
  while (!(inportb(0x3da)&8));
}
/**/
void rottex(float a,float sc)
{

  int i,j,adr;

  float x,y,c,s,ys,yc;
  int tx,ty;

  float txc[320],txs[320];



  c=cos(a*PI/180);
  s=sin(a*PI/180);

  for (j=0;j<320;j++)
    {

      txc[j]=(j-160)*c;
      txs[j]=(j-160)*s;
    }


  adr=0;

  for (i=0;i<200;i++)
  {
    y=i-100;

    ys=y*s;
    yc=y*c;


    for (j=0;j<320;j++)


      {

         tx=txc[j]-ys+160.0;
         ty=txs[j]+yc+100.0;


         scr[adr++]=bmp[ ((ty<<8)+tx)&0xffff];


      }

  }

}
/**/
static int col;
static int c,s;
static int xc,xs;

void rottexfix8(float a,float sc)
{

  int i,j,n,adr,adr1;

  int x,y,ys,yc,xct,xst;
  int tx,ty;


  int yl,xl;

  int dx,dy;


//  char *scr=screen;

  c=cos(a*PI/180)*sc*65536.0;
  s=sin(a*PI/180)*sc*65536.0;


  adr=0;

  xl=0;
  yl=0;



  for (n=0;n<1000;n++)

    {

        adr=(yl<<6)+(yl<<8)+xl;

        yc=(yl-100)*c+(100<<16);
        ys=(yl-100)*s+(100<<16);

        xct=(xl-160)*c;
        xst=(xl-160)*s;

        for (i=0;i<8;i++)
        {


          xc=xct-ys;
          xs=xst+yc;

          asm (

            "

                 pushl %%ebp;

                 movl _c,%%ebp;
                 movl _s,%%esi;
                 movl _xs,%%ebx;
                 movl _xc,%%eax;
                 movl $8,%%ecx;


                 lea   (%%edi,%%ecx),%%edi;
                 xor $-1,%%ecx;
                 incl %%ecx;


            n_x:
                 rorl $16,%%ebx;

                 movb %%bh,%%dl;
                 movb %%bl,%%dh;

                 rorl $16,%%ebx;

                 rorl $16,%%eax;
                 addw %%ax,%%dx;
                 rorl $16,%%eax;


                 addl %%ebp,%%eax;
                 addl %%esi,%%ebx;



                 movb (%%edx),%%dl;
                 movb %%dl,(%%edi,%%ecx);


                 incl %%ecx;
                 jnz n_x;

                 popl %%ebp;

                 "
             :
             : "d" (bmp), "D" (scr+adr)
             : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi"
            );

/*          for (j=0;j<8;j++)
          {
            scr[adr++]=bmp[( ((xs>>16)<<8)+(xc>>16) )&0xffff];
            xc+=c;xs+=s;

          }             */
          adr+=320;
          yc+=c;
          ys+=s;
      
        }


        xl+=8;
        if (xl==320) {yl+=8;xl=0;}
    }


}
/**/
void rottexfix82(float a,float sc)
{

  int i,j,n,adr,adr1;

  int x,y,ys,yc,xct,xst;
  int tx,ty;


  int yl,xl;

  int dx,dy;


//  char *scr=screen;

  c=cos(a*PI/180)*sc*65536.0;
  s=sin(a*PI/180)*sc*65536.0;


  adr=0;

  yc=(-100)*c+(100<<16);
  ys=(-100)*s+(100<<16);

  xct=(-160)*c;
  xst=(-160)*s;

  for (i=0;i<200;i++)
  {


    xc=xct-ys;
    xs=xst+yc;

    asm (

      "

           pushl %%ebp;

           movl _c,%%ebp;
           movl _s,%%esi;
           movl _xs,%%ebx;
           movl _xc,%%eax;
           movl $320/4,%%ecx;


           lea   (%%edi,%%ecx),%%edi;
           xor $-1,%%ecx;
           incl %%ecx;


      nx:
           rorl $16,%%ebx;

           movb %%bh,%%dl;
           movb %%bl,%%dh;

           rorl $16,%%ebx;

           rorl $16,%%eax;
           addw %%ax,%%dx;
           rorl $16,%%eax;



           addl %%ebp,%%eax;
           addl %%esi,%%ebx;



           movb (%%edx),%%dl;
           movb %%dl,_col;
           shrl $8,_col;

           rorl $16,%%ebx;

           movb %%bh,%%dl;
           movb %%bl,%%dh;

           rorl $16,%%ebx;

           rorl $16,%%eax;
           addw %%ax,%%dx;
           rorl $16,%%eax;



           addl %%ebp,%%eax;
           addl %%esi,%%ebx;



           movb (%%edx),%%dl;
           movb %%dl,_col;
           shrl $8,_col;

           rorl $16,%%ebx;

           movb %%bh,%%dl;
           movb %%bl,%%dh;

           rorl $16,%%ebx;

           rorl $16,%%eax;
           addw %%ax,%%dx;
           rorl $16,%%eax;



           addl %%ebp,%%eax;
           addl %%esi,%%ebx;



           movb (%%edx),%%dl;
           movb %%dl,_col;
           shrl $8,_col;

           rorl $16,%%ebx;

           movb %%bh,%%dl;
           movb %%bl,%%dh;

           rorl $16,%%ebx;

           rorl $16,%%eax;
           addw %%ax,%%dx;
           rorl $16,%%eax;



           addl %%ebp,%%eax;
           addl %%esi,%%ebx;



           movb (%%edx),%%dl;
           movb %%dl,_col;
           movl _col,%%edx;
           movl %%edx,(%%edi,%%ecx);

           addl $4,%%ecx;
           jnz nx;

           popl %%ebp;

           "
       :
       : "d" (bmp), "D" (scr+adr)
       : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi"
      );


    adr+=320;
    yc+=c;
    ys+=s;

  }



}
/**/
void rottexfix84(float a,float sc)
{

  int i,j,n,adr,adr1;

  int x,y,ys,yc,xct,xst;
  int tx,ty;


  int yl,xl;

  int dx,dy;


//  char *scr=screen;

  c=cos(a*PI/180)*sc*65536.0;
  s=sin(a*PI/180)*sc*65536.0;


  adr=0;

  yc=(-100)*c+(100<<16);
  ys=(-100)*s+(100<<16);

  xct=(-160)*c;
  xst=(-160)*s;

  for (i=0;i<200;i++)
  {


    xc=xct-ys;
    xs=xst+yc;

    asm (

      "

           pushl %%ebp;

           movl _c,%%ebp;
           movl _s,%%esi;
           movl _xs,%%ebx;
           movl _xc,%%eax;
           movl $320,%%ecx;


           lea   (%%edi,%%ecx),%%edi;
           xor $-1,%%ecx;
           incl %%ecx;


      nx1:
           rorl $16,%%ebx;

           movb %%bh,%%dl;
           movb %%bl,%%dh;

           rorl $16,%%ebx;

           rorl $16,%%eax;
           addw %%ax,%%dx;
           rorl $16,%%eax;



           addl %%ebp,%%eax;
           addl %%esi,%%ebx;



           movb (%%edx),%%dl;
           movb %%dl,(%%edi,%%ecx);

           incl %%ecx;
           jnz nx1;

           popl %%ebp;

           "
       :
       : "d" (bmp), "D" (scr+adr)
       : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi"
      );


    adr+=320;
    yc+=c;
    ys+=s;

  }



}
/**/
void show_bitmap(char *scr,int x,int y)
{

  int i,s;

  s=x;
  if (x>320) s=320;
  if (y>200) y=200;

  for(i=0;i<y;i++)

    memcpy(&screen[i*320],&scr[i*x],s);

}
/**/

pal8 pal[256];


int main()
{
  int h,k,a;
  short int _DS_;
  int dx,dy;
  int ss=0;
  int sint[360];
  int cirx[360];
  int ciry[360];
  float l=0.04,z;

  int w;
  unsigned char b;

  unsigned long screen_base_addr;


  __djgpp_nearptr_enable();
  __dpmi_get_segment_base_address(_dos_ds, &screen_base_addr);
  _DS_=_my_ds();
  scr=(unsigned char *) malloc(320*200);
  texture=(unsigned char *) malloc(256*256);
  bmpa=(unsigned char *) malloc(256*256*2);
  screen = (unsigned char *)(screen_base_addr +
                             0xA0000 -
                             __djgpp_base_address);



  load_bmp("dgs256.bmp",texture,pal);

  setmode(0x13);

  set_palette(pal);


  w=50;

  for (i=0;i<360;i++){ sint[i]=sin(4*i*PI/180.0)*w; if (i<180) w++; else w--; }


  MAX_DOT=4;



  bmp=(unsigned char *) ((long)(bmpa+0xffff) & ~0xffff) ;
 // bmp=bmpa;

  memcpy(bmp,texture,256*256);
/*
  for (j=0;j<256;j++)
    for (i=240;i<256;i++)
      bmp[j*256+i]=255;*/


  load_bmp("dgs_bg.bmp",texture,pal);




  a=0;
  z=1;


  do {



      z+=l;
      if (z>8.0 || z<0.0) l=-l;


      a+=1;if (a>359) a=0;


/*
      outportb(0x3c8,0);
      outportb(0x3c9,63);
      outportb(0x3c9,0);
      outportb(0x3c9,0);*/

 //     memcpy(screen,scr,64000);



        asm (
        "
            movl $16000,%%ecx;

        next:

            movb (%%esi),%%al;
            cmpb $255,%%al;

            jnz ok0;

            movb (%%ebx),%%al;


        ok0:

            movb 1(%%esi),%%ah;
            cmpb $255,%%ah;

            jnz ok1;

            movb 1(%%ebx),%%ah;


        ok1:

            shll $16,%%eax;


            movb 2(%%esi),%%al;
            cmpb $255,%%al;

            jnz ok2;

            movb 2(%%ebx),%%al;


        ok2:


            movb 3(%%esi),%%ah;
            cmpb $255,%%ah;

            jnz ok3;

            movb 3(%%ebx),%%ah;


        ok3:

            roll $16,%%eax;


            movl  %%eax,(%%edi);


            addl $4,%%esi;
            addl $4,%%ebx;
            addl $4,%%edi;


            decl %%ecx;

            jnz next;


        "

        :
        : "S" (scr), "D" (screen), "b" (texture)
        : "%eax","%edi","%esi","%ebx"

        );
      rottexfix84(a,z);
/*
      outportb(0x3c8,0);
      outportb(0x3c9,0);
      outportb(0x3c9,0);
      outportb(0x3c9,0);*/

      vbl();


  } while (!kbhit());

  setmode(0x03);

  free(scr);
  free(bmp);
  free(bmpa);

  return 0;
}
